from PyTango import Util, DevFailed
import sys
from keithley20xx.device import KeithleyDevice, KeithleyBaseClass, \
    Keithley2001Class
from keithley20xx import __version__

SERVER_NAME = 'Keithley'


class Keithley2010(KeithleyDevice):
    pass


class Keithley2001(KeithleyDevice):
    pass


def run(args=None):
    print('Device Server Version: %s' % __version__)

    try:
        if not args:
            args = sys.argv[1:]
            args = [SERVER_NAME] + list(args)
        util = Util(args)
        util.add_class(Keithley2001Class, Keithley2001)
        util.add_class(KeithleyBaseClass, Keithley2010)
        u = Util.instance()
        u.server_init()
        u.server_run()

    except DevFailed as e:
        print('-------> Received a DevFailed exception:', e)
    except Exception as e:
        print('-------> An unforeseen exception occurred....', e)

if __name__ == '__main__':
    run()

